import re
def mosaic_string(s):
  return re.sub(r"\d+", "*", s)

def func():
  chars = ['*', '#']
  index = 0
  def _func(m):
    nonlocal index
    index = (index + 1) % len(chars)
    return chars[index] * len(m.group())
  return _func

class CyclicMosaic:
  chars = ['*', '#']
  def __init__(self):
    self.index = 0
  def generate(self, m):
    char = self.chars[self.index]
    self.index = (self.index + 1) % len(self.chars)
    length = len(m.group())
    return char * length

def mosaic_func(s):
  # return re.sub(r"\d+", func(), s)
  return re.sub(r'\d+', CyclicMosaic().generate, s)

# c = mosaic_string("商店共 100个苹果，小明以12 元每斤的价格买走了8个")
c = mosaic_func("商店共 100个苹果，小明以12 元每斤的价格买走了8个")
print(c)
# '商店共 * 个苹果，小明以* 元每斤的价格买走了* 个'

